#!/bin/bash

if [ $# -lt 1 ] ; then
	echo "usage: $0 jobname"
	exit 1
fi

jobname=$1
cgroupdir=/cgroup/$jobname
vardir=/var/lib/crdemo/$jobname

if [ ! -d "$cgroupdir" ]; then
	echo "$cgroupdir does not exist"
	exit 1
fi
if [ ! -d "$vardir" ]; then
	echo "$vardir does not exist"
	exit 1
fi
pid=`head -1 $cgroupdir/tasks`
echo FROZEN > $cgroupdir/freezer.state

echo "checkpoint -N -l $vardir/log $pid > $vardir/ckpt"
/usr/bin/appcheckpoint -N -l $vardir/log $pid > $vardir/ckpt
ret=$?
if [ $ret -ne 0 ]; then
	echo "checkpoint failed with return code $ret"
	echo "log says:"
	cat $vardir/log
else
	echo "checkpoint succeeded"
	kill -9 $pid
fi
sleep 1
echo THAWED > $cgroupdir/freezer.state
exit $ret
